/*
 * BundleUtil.java
 *
 * Created on 07 July 2006, 11:25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jim.common;

import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

/**
 * Utility class for managing a group of resource bundles (property files)
 * @author briggsj
 */
public class BundleUtil {
    
    /** Creates a new instance of BundleUtil */
    public BundleUtil() {
    }
 
    static private Map<String, ResourceBundle> bundles = new HashMap<String, ResourceBundle>();
    
    /**
     * Get a named property from a name resource bundle
     * @param bundlename the name of the resource bundle
     * @param property the name of the property
     * @return the value of the property; null if non-existent
     */
    static public String getProperty(String bundlename, String property) {
        ResourceBundle b = bundles.get(bundlename);
        if (b == null) {
            b = ResourceBundle.getBundle(bundlename);
            bundles.put(bundlename, b);
        }
        return b.getString(property);
    }
    
    static public String getProperty(String bundlename, String property, String dflt) {
        String value = getProperty(bundlename, property);
        if (value == null) {
            return dflt;
        } else {
            return value;
        }
    }
}
