/*
 * MessageProcess.java
 *
 * Created on 19 April 2005, 20:57
 */

package jim.mailapp;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import jim.common.mail.DBMessageFetcher;
import jim.common.mail.DBRecipientFetcher;
import jim.common.mail.EmailMessage;
import jim.common.mail.RecipientException;
import jim.util.SqlUtils;

import org.apache.struts.util.LabelValueBean;

/**
 *
 * @author  briggsj
 */
public class MessageProcess {
    
    //TODO Is this the right place to synchronize methods?
    
    private SqlUtils sql = null;
    private DBMessageFetcher mf = null;
    private DBRecipientFetcher rf = null;
    
    private void initmf() {
        if (mf == null) {
            mf = new DBMessageFetcher(sql, "MESSAGES", "KEY", "VALUE");
        }
    }
    
    private void initrf() {
        if (rf == null) {
            rf = new DBRecipientFetcher(sql, "STUDENT", "NAME", "EMAIL");
        }
    }
    
    /** Creates a new instance of MessageProcess */
    public MessageProcess() throws Exception {
        if (sql == null) {
            Connection conn = MailApp.getInstance().getConnection();
            sql = new SqlUtils(conn);
        }
    }
    
    public synchronized Map<String,String> getMessages() {
        initmf();
        mf.fetchAllStrings();
        return mf.getMessages();
    }
    
    protected synchronized void finalize() throws Throwable {
        super.finalize();
    }
    
    public synchronized EmailMessage getEmailMessage(String messageName) {
        initmf();
        return mf.fetch(messageName);
    }
    
    public synchronized void setMessage(String messageName, String value) {
        initmf();
        mf.storeString(messageName, value);
    }
    
    public synchronized List makeComposeMessageBean() {
        List<LabelValueBean> beans = new ArrayList<LabelValueBean>();
        LabelValueBean header = new LabelValueBean("Open message...", "");
        beans.add(header);
        
        Map<String,String> msgs = this.getMessages();
        List<String> keys = new ArrayList<String>(msgs.keySet());
        Collections.sort(keys);
        
        Iterator it = keys.iterator();
        while (it.hasNext()) {
            String key = (String)it.next();
            String value = (String)msgs.get(key);
            
            LabelValueBean lvb = new LabelValueBean(key, key);
            beans.add(lvb);
        }
        return beans;
    }
    
    public List getRecipients(List courses) throws RecipientException {
        initrf();
        rf.fetchAllStudentsByCourse(courses);
        return rf.getAddresses();
    }
    
    public List getCourses(String annum) throws SQLException {
        initrf();
        return rf.getCourses(annum);
    }
}
