/*
 * HiberConnectionProvider.java
 *
 * Created on 05 June 2006, 16:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jim.util.hiber;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Properties;
import jim.common.Logger;
import jim.util.MultiDataSource;
import org.apache.commons.logging.Log;
import org.hibernate.HibernateException;

/**
 *
 * @author briggsj
 */
public class HiberConnectionProvider implements org.hibernate.connection.ConnectionProvider {
    
    static private Log log = Logger.getLog(HiberConnectionProvider.class);
    
    private MultiDataSource ds = null;
    
    /** Creates a new instance of HiberConnectionProvider */
    public HiberConnectionProvider() {
        
    }
    
    public void configure(Properties properties) throws HibernateException {
        ds = new jim.util.MultiDataSource();
        
        String name = properties.getProperty("hibernate.connection.multidatabase", "jdbc/db");
        ds.setEnvName(name);
        log.info("Connection provider using multidatabase " + name);
    }
    
    public void closeConnection(Connection connection) throws SQLException {
        connection.close();
    }
    
    public boolean supportsAggressiveRelease() {
        return false;
    }
    
    public Connection getConnection() throws SQLException {
        return ds.getConnection();
    }
    
    public void close() throws HibernateException {
    }
    
}
