import java.beans.PropertyDescriptor;
import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import javax.servlet.http.HttpServletRequest;
import jim.util.hiber.HibernateUtil;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.hibernate.EntityMode;
import org.hibernate.metadata.ClassMetadata;

public abstract class AbstractForm extends ActionForm {
    
    public void reset(ActionMapping mapping, HttpServletRequest request) {
        super.reset( mapping, request );
        
        // Get PropertyDescriptor of all bean properties
        PropertyDescriptor descriptors[] = PropertyUtils.getPropertyDescriptors( this );
        
        for ( int i = 0; i < descriptors.length; i++ ) {
            Class propClass = descriptors[i].getPropertyType();
            
            ClassMetadata classMetadata = HibernateUtil.getSessionFactory().getClassMetadata( propClass );
            try {
                if ( classMetadata != null ) {   // This is a Hibernate object
                    String propName = descriptors[i].getName();
                    Object propValue = PropertyUtils.getProperty( this, propName );
                    
                    // Evaluate property, create new instance if it is null
                    if ( propValue == null ) {
                        PropertyUtils.setProperty( this, propName, propClass.newInstance() );
                    }
                }
            } catch (Exception ex) {
                ///ignore
            }
        }
    }
    
    public void cleanupEmptyObjects() {
        // Get PropertyDescriptor of all bean properties
        PropertyDescriptor descriptors[] = PropertyUtils.getPropertyDescriptors( this );
        
        for ( int i = 0; i < descriptors.length; i++ ) {
            Class propClass = descriptors[i].getPropertyType();
            ClassMetadata classMetadata = HibernateUtil.getSessionFactory().getClassMetadata( propClass );
            
            if ( classMetadata != null ) {   // This is a Hibernate object
                Serializable id = classMetadata.getIdentifier( this, EntityMode.POJO );
                
                // If the object id has not been set, release the object.
                // Define application specific rules of not-set id here,
                // e.g. id == null, id == 0, etc.
                if ( id == null ) {
                    String propName = descriptors[i].getName();
                    try {
                        PropertyUtils.setProperty( this, propName, null );
                    } catch (Exception ex) {
                        //ignore
                    }
                }
            }
        }
    }
}