/*
 * JimActionError.java
 *
 * Created on 19 August 2004, 16:37
 */

package jim.util.struts;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Iterator;
import java.util.List;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

/**
 *
 * @author  briggsj
 */
public class JimActionErrors extends ActionErrors {
    
    /** Creates a new instance of JimActionError */
    public JimActionErrors() {
    }
    
    public void add(String property, String token, String msg) {
        add(property, new ActionMessage(token, msg));
    }
    
    public void add (List<String> messages) {
        Iterator<String> it = messages.iterator();
        while (it.hasNext()) {
            String s = it.next();
            addGlobal("free.text", s);
        }
    }
    
    public void addGlobal(String token, String msg) {
        add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(token, msg));
    }
    
    public void add(String property, String token, Object[] msg) {
        add(property, new ActionMessage(token, msg));
    }
    
    public void addGlobal(String token, Object[] msg) {
        add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(token, msg));
    }
    
    public void addException(Throwable t) {
        if (t == null) {
            addGlobal("pums.exception", "Exception without a cause!");
        } else {
            StringWriter s = new StringWriter();
            t.printStackTrace(new PrintWriter(s));
//            StackTraceElement[] st = t.getStackTrace();
            addGlobal("pums.exception", s.getBuffer().toString());
        }
    }
    
    public void check(String s, String label, int min, int max) {
        int n;
        if (s == null) {
            n = 0;
        } else {
            n = s.length();
        }
        if (n < min) {
            add(label, "pums.errors.stringTooShort", new Integer[]{new Integer(min), new Integer(n)});
        }
        if (n > max) {
            add(label, "pums.errors.stringTooLong", new Integer[]{new Integer(n-max), new Integer(max)});
        }
    }
    
    public void check(int i, String label, int min, int max) {
        if (i < min || i > max) {
            add(label, "pums.errors.outOfRange", new Integer[]{new Integer(min), new Integer(max)});
        }
    }
}
